/**
 ** Copyright (c) 2002 Sun Microsystems, Inc.
 **
 ** See the file "license.terms" for information on usage and redistribution
 ** of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 **/

/**
 **  gcspy_server_state.cpp
 **
 **  The state maintained by the GCspy server
 **/

#include "gcspy_server_state.hpp"

gcspyServerState::gcspyServerState () {
  reset_flags();
  reset_event_filters();
}

void
gcspyServerState::reset_flags () {
  _pause_req    = 0;
  _restart      = 0;
  _play_one     = 0;
  _shutdown_req = 0;
}

void
gcspyServerState::reset_event_filters () {
  for (int i = 0; i < max_events; ++i) {
    _enabled[i] = 1;
    _delays[i] = 0;
    _paused[i] = 0;
    _periods[i] = 1;
  }
}
