/**
 ** Copyright (c) 2002 Sun Microsystems, Inc.
 **
 ** See the file "license.terms" for information on usage and redistribution
 ** of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 **/

/**
 **  gcspy_shape_stream.cpp
 **
 **  Instantiation of the command stream
 **/

#include <stdio.h>

#include "gcspy_shape_stream.hpp"

/* FIXME g++ 4.1.2 complains that ‘point_cmd’ was not declared in this scope
 * if it's used in this file before it's declared!!
gcspyShapeStream::gcspyShapeStream ()
  : gcspyCommandStream(last_tag + 1) {
  _cmds[point_tag] = point_cmd;
  _cmds[circle_tag] = circle_cmd;
  _cmds[rectangle_tag] = rectangle_cmd;
}
*/

// POINT

void
point_cmd (gcspyBufferedInput *input, void *aux) {
  int x = input->read_int();
  int y = input->read_int();
  printf("Point (%d, %d)\n", x, y);
}

void
gcspyShapeStream::put_point (gcspyBufferedOutput *output,
			     int x, int y) {
  put_tag(output, point_tag);
  output->write_int(x);
  output->write_int(y);
}

// CIRCLE

void
circle_cmd (gcspyBufferedInput *input, void *aux) {
  int x = input->read_int();
  int y = input->read_int();
  int rad = input->read_int();
  printf("Circle (%d, %d), %d\n", x, y, rad);
}

void
gcspyShapeStream::put_circle (gcspyBufferedOutput *output,
			      int x, int y, int rad) {
  put_tag(output, circle_tag);
  output->write_int(x);
  output->write_int(y);
  output->write_int(rad);
}

// RECTANGLE

void
rectangle_cmd (gcspyBufferedInput *input, void *aux) {
  int x1 = input->read_int();
  int y1 = input->read_int();
  int x2 = input->read_int();
  int y2 = input->read_int();
  printf("Rectangle (%d, %d), (%d, %d)\n", x1, y1, x2, y2);
}

void
gcspyShapeStream::put_rectangle (gcspyBufferedOutput *output,
				 int x1, int y1, int x2, int y2) {
  put_tag(output, rectangle_tag);
  output->write_int(x1);
  output->write_int(y1);
  output->write_int(x2);
  output->write_int(y2);
}
gcspyShapeStream::gcspyShapeStream ()
  : gcspyCommandStream(last_tag + 1) {
  _cmds[point_tag] = point_cmd;
  _cmds[circle_tag] = circle_cmd;
  _cmds[rectangle_tag] = rectangle_cmd;
}
