package gcspy.vis;

import javax.swing.AbstractListModel;
import javax.swing.ListModel;

/**
 * {@link ListModel} that uses a backing array.
 * 
 * @author Peter Hofer
 * 
 * @param <T>
 *            Type of objects stored in the array.
 */
public class ArrayListModel<T> extends AbstractListModel {

	private T[] array;

	/**
	 * Constructor.
	 * 
	 * @param array
	 *            The array to use as backing store.
	 */
	public ArrayListModel(T[] array) {
		this.array = array;
	}

	@Override
	public T getElementAt(int index) {
		return array[index];
	}

	@Override
	public int getSize() {
		return array.length;
	}

	/**
	 * @return the backing array.
	 */
	public T[] getArray() {
		return array;
	}
}
