package gcspy.vis;

import gcspy.comm.SocketServer;
import gcspy.tools.TerminalPlayTrace;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * {@link EnhancedThread} for running a {@link TerminalPlayTrace} instance's
 * main loop.
 * 
 * @author Peter Hofer
 */
class PlayTraceThread extends EnhancedThread {

	private static final Logger logger = Logger.getLogger(PlayTraceThread.class.getName());

	private final TerminalPlayTrace playTrace;

	public PlayTraceThread(TerminalPlayTrace playTrace) {
		this.playTrace = playTrace;
	}

	public void execute() {
		try {
			playTrace.bind(SocketServer.ANY_PORT, true);
			setName(PlayTraceThread.class.getSimpleName() + " :" + playTrace.getBindPort());

			playTrace.go();
		} catch (Exception e) {
			logger.log(Level.WARNING, "Exception caught, stopping trace replay", e);
		}
	}
}
