package gcspy.vis;

import gcspy.interpreter.Space;

/**
 * Tile representing a block in a space. Immutable.
 * 
 * @author Peter Hofer
 */
class Tile {
	private final Space space;
	private final int[] streams;
	private final int index;

	/**
	 * Constructor.
	 */
	public Tile(Space space, int[] streams, int index) {
		this.space = space;
		this.streams = streams;
		this.index = index;
	}

	/**
	 * @return Space that contains this tile.
	 */
	public Space getSpace() {
		return space;
	}

	/**
	 * @return Stream that this tile displays.
	 */
	public int[] getStreams() {
		return streams;
	}

	/**
	 * @return Index of this tile within the space.
	 */
	public int getIndex() {
		return index;
	}
}