package gcspy.vis;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

/**
 * {@link PropertyView} that displays a collection of {@link PropertyItem}
 * objects provided in an array.
 * 
 * @author Peter Hofer
 */
public class TilePropertyView extends AbstractPropertyView<PropertyItem[]> {

	private ActionListener copyClipboardListener = new ActionListener() {
		@Override
		public void actionPerformed(ActionEvent e) {
			copyToClipboard();
		}
	};

	private PropertyListView view;
	private JScrollPane pane;

	private JPanel buttonPanel;
	private JButton toClipboardB;

	private ArrayListModel<PropertyItem> model;

	/**
	 * Constructor.
	 */
	public TilePropertyView() {
		setLayout(new BorderLayout());

		view = new PropertyListView();
		pane = new JScrollPane(view);
		add(pane, BorderLayout.CENTER);

		toClipboardB = new JButton("Copy to Clipboard");
		toClipboardB.addActionListener(copyClipboardListener);
		toClipboardB.setEnabled(false);
		toClipboardB.setVisible(false);

		buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		buttonPanel.add(toClipboardB);
		add(buttonPanel, BorderLayout.SOUTH);
	}

	public void setCopyToClipboardVisible(boolean visible) {
		toClipboardB.setVisible(visible);
	}

	public void copyToClipboard() {
		view.copyToClipboard();
	}

	@Override
	protected void setPropertyData(PropertyItem[] properties) {
		model = new ArrayListModel<PropertyItem>(properties);
		view.setModel(model);

		toClipboardB.setEnabled(true);
	}
}
